declare class BorumRequest {
    private headers;
    private init;
    private url;
    constructor(input: string, init?: RequestInit);
    static initialize(input: string, init?: RequestInit): BorumRequest;
    authorize(userApiKey?: string | null): BorumRequest;
    post(body: string): BorumRequest;
    put(body: string): BorumRequest;
    delete(body: string): BorumRequest;
    makeRequest(abortController?: AbortController): Promise<Response>;
}
